#version 330

// Directly use the position for color
//#define RGB_POSITION
// Use the position to compute color
//#define RGB_COLOR
// Rotate the geometry 90 degrees ccw
//#define ROTATED

uniform mat4 m_pvm;

in vec4 position;	// local space

#if defined(RGB_POSITION) || defined(RGB_COLOR)
out vec4 color;
#endif

//----------------------------------------------------------------
// TODO:
// 1) Output the projected vertex.
// 2) Output the rotated and projected vertex.
// 3) Color the vertex based on its position.
// 4) Color the vertex based on its x-coordinate as RGB.
//----------------------------------------------------------------

void main()
{
#if defined(RGB_POSITION)
	color = position;
#elif defined(RGB_COLOR)
	if(position.x == -1.f)
		color = vec4(1.f, 0.f, 0.f, 1.f);
	else if(position.x == 0.f)
		color = vec4(0.f, 1.f, 0.f, 1.f);
	else if(position.x == 1.f)
		color = vec4(0.f, 0.f, 1.f, 1.f);
#endif
	
#ifndef ROTATED
	gl_Position = m_pvm * position;
#else	
	float angle = 3.14f / 2.f;
	mat4 matRot = mat4(vec4(cos(angle), sin(angle), 0.f, 0.f), vec4(-sin(angle), cos(angle), 0.f, 0.f), vec4(0.f, 0.f, 1.f, 0.f), vec4(0.f, 0.f, 0.f, 1.f));
	gl_Position = m_pvm * matRot * position;
#endif
}